import { jsx as de } from "react/jsx-runtime";
import { useMemo as X, useState as fe, useRef as xe, useLayoutEffect as Ce } from "react";
import * as te from "helper-js";
import { VirtualList as Pe } from "react-base-virtual-list";
/*!
 * he-tree-react
 * Author: phphe <phphe@outlook.com> (https://github.com/phphe)
 * Released under the MIT License.
 */
const ne = {
  id: null,
  x: 0,
  y: 0,
  time: 0
}, Ke = {
  /**
   * 
   */
  idKey: "id",
  parentIdKey: "parent_id",
  childrenKey: "children",
  indent: 20,
  dragOpen: !1,
  dragOpenDelay: 600,
  placeholderId: "__DRAG_PLACEHOLDER__",
  dataType: "flat",
  direction: "ltr",
  rootId: null,
  virtual: !1
};
function Me(s) {
  const e = { ...Ke, ...s }, { idKey: n, parentIdKey: t, childrenKey: p, placeholderId: h, isFunctionReactive: I } = e, c = { idKey: n, parentIdKey: t };
  if (!e.renderNode && !e.renderNodeBox)
    throw new Error("Either renderNodeBox or renderNode is required.");
  const a = e.direction === "rtl", l = X(() => e.openIds ? [...e.openIds].sort().toString() : void 0, [e.openIds]), D = X(() => new Set(e.openIds), [l]), m = X(() => e.checkedIds ? [...e.checkedIds].sort().toString() : "", [e.checkedIds]), K = X(() => new Set(e.checkedIds), [m]), C = X(
    () => {
      var le, o;
      const E = {}, _ = {}, F = [], z = [], V = [], J = [];
      function* ie() {
        if (e.dataType === "flat")
          for (const r of e.data)
            yield [r];
        else
          for (const r of j(e.data, p))
            yield r;
      }
      let U = 0;
      for (const [r, i] of ie()) {
        const u = r[n] ?? U;
        J.push(u);
        let P = r[t];
        e.dataType === "tree" && (P = ((le = i.parent) == null ? void 0 : le[n]) ?? null);
        let L = _[P] || null;
        const y = E[P] || null, g = [], S = [], T = [];
        let v, b, N;
        y ? (v = y.childIds, b = y.children, N = y.childStats) : (v = F, b = z, N = V);
        const B = v.length, H = (y == null ? void 0 : y.level) + 1 || 1, ce = {
          _isStat: !0,
          id: u,
          pid: P,
          childIds: g,
          siblingIds: v,
          node: r,
          parent: L,
          parentStat: y,
          children: S,
          childStats: T,
          siblings: b,
          siblingStats: N,
          index: B,
          level: H,
          open: e.openIds ? D.has(u) : !0,
          checked: K.has(u),
          draggable: !1
        };
        E[u] = ce, _[u] = r, v.push(u), b.push(r), N.push(ce), U++;
      }
      for (const [r] of j(V, "childStats")) {
        let i = ((o = e.canDrag) == null ? void 0 : o.call(e, r)) ?? null;
        i === null && (i = r.parentStat ? r.parentStat.draggable : !0), r.draggable = i;
      }
      return {
        // root
        rootIds: F,
        rootNodes: z,
        rootStats: V,
        // 
        allIds: J,
        // methods
        getStat: (r) => {
          let i;
          return typeof r == "object" ? i = r._isStat ? r.id : r[n] : i = r, E[i];
        }
      };
    },
    [
      e.data,
      e.dataType,
      n,
      t,
      D,
      K,
      I && e.canDrag
    ]
  ), { rootIds: R, rootStats: O, getStat: d } = C, x = e.indent, [f, w] = fe(), [M, A] = fe(), Y = xe(null), $ = xe(null), [k, ee] = fe(), re = !f, we = X(
    () => {
      const E = [], _ = [];
      for (const [o, { skipChildren: r }] of j(O, "childStats")) {
        const i = F(o);
        o === f && (Object.assign(i.style, {
          position: "fixed",
          top: 0,
          left: 0,
          pointerEvents: "none",
          zIndex: "-999999999",
          visibility: "hidden"
        }), i["data-dragging"] = !0), _.push(i), E.push(o.id), (!o.open || o === f) && r();
      }
      if (k) {
        const r = ((u, P) => {
          let L = ((u == null ? void 0 : u.childStats) || O)[P], y;
          if (L)
            y = E.indexOf(L.id);
          else {
            const g = (T) => T.siblingStats[T.siblingStats.indexOf(T) + 1];
            let S;
            if (u) {
              for (const T of Se(u, "parentStat", { withSelf: !0 }))
                if (S = g(T), S)
                  break;
            }
            S ? y = E.indexOf(S.id) : y = E.length;
          }
          return y;
        })(k.parentStat, k.index);
        E.splice(r, 0, h);
        const i = F({
          id: h,
          level: k.level
        }, !0);
        i["data-drag-placeholder"] = !0, _.splice(r, 0, i);
      }
      function F(o, r = !1) {
        return {
          key: o.id,
          draggable: o.draggable,
          style: { [`padding${a ? "Right" : "Left"}`]: (o.level - 1) * x + "px" },
          "data-key": o.id + "",
          "data-level": o.level + "",
          "data-node-box": !0,
          onDragStart(i) {
            var y;
            if (r) {
              i.preventDefault();
              return;
            }
            let u;
            const P = te.findParent(i.target, (g) => (!u && g.hasAttribute("draggable") && (u = g), g.hasAttribute("data-node-box")), { withSelf: !0 });
            if (P.querySelector("[draggable]") && u === P) {
              i.preventDefault();
              return;
            }
            if (i.dataTransfer.setData("text/plain", "he-tree he-tree-react"), i.dataTransfer.dropEffect = "move", e.customDragImage)
              e.customDragImage(i, o);
            else {
              const g = P.children[0];
              i.dataTransfer.setDragImage(g, a ? g.offsetWidth : 0, 0);
            }
            setTimeout(() => {
              var g;
              w(o), ee({
                ...k,
                parentStat: o.parentStat,
                level: o.level,
                index: (((g = o.parentStat) == null ? void 0 : g.childIds) || R).indexOf(o.id)
              });
            }, 0), (y = e.onDragStart) == null || y.call(e, i, o);
          },
          onDragLeave(i) {
          }
        };
      }
      const z = (o) => {
        var P, L, y;
        if (re && !((P = e.onExternalDragOver) != null && P.call(e, o)))
          return;
        const r = i();
        if (r) {
          const g = d(r.getAttribute("data-key")), S = !!r.getAttribute("data-drag-placeholder");
          u(g, S) && e.onDragOpen(g);
          let T = he(g, S);
          const { closest: v, next: b } = T;
          let { atTop: N } = T;
          const B = $.current, H = r;
          let pe = (() => {
            let G = H.getBoundingClientRect(), W;
            return a ? W = Math.ceil((G.right - o.pageX) / x) : W = Math.ceil((o.pageX - G.x) / x), te.between(W, 0, ((v == null ? void 0 : v.level) || 0) + 1);
          })();
          if (!N && !S && v.id === R[0]) {
            const G = B.querySelector(`[data-key="${v.id}"]`);
            if (G) {
              const W = G.getBoundingClientRect();
              N = W.y + W.height / 2 > o.pageY;
            }
          }
          N && (pe = 0);
          let ae;
          if (N)
            U(null, 0) && (ae = {
              ...k,
              parentStat: null,
              level: 1,
              index: 0
            });
          else {
            const G = b ? b.level - 1 : 0, W = [], Ie = [];
            let q = v;
            const De = () => q ? q.level : 0;
            for (; De() >= G; ) {
              const ye = le(q, b);
              if (U(q, ye) && (pe > De() ? W : Ie).unshift({
                parentStat: q,
                index: ye
              }), !q)
                break;
              q = q.parentStat;
            }
            let Q = te.arrayLast(W);
            Q || (Q = te.arrayFirst(Ie)), Q && (ae = {
              ...k,
              parentStat: Q.parentStat,
              level: (((L = Q.parentStat) == null ? void 0 : L.level) ?? 0) + 1,
              index: Q.index
            });
          }
          ee(ae), ae && o.preventDefault(), A(S ? void 0 : g), (y = e.onDragOver) == null || y.call(e, o, g, re);
        } else
          U(null, 0) && (ee({
            ...k,
            parentStat: null,
            level: 1,
            index: 0
          }), o.preventDefault());
        function i() {
          const S = $.current.querySelectorAll("[data-node-box]:not([data-dragging])"), T = te.binarySearch(
            // @ts-ignore
            S,
            (b) => b.getBoundingClientRect().top - o.pageY,
            { returnNearestIfNoHit: !0 }
          );
          let v;
          return T.hit || T.greater && (v = T.index - 1, v < 0 && (v = 0)), v == null && (v = T.index), S[v];
        }
        function u(g, S) {
          if (!e.dragOpen || S || g.open)
            return !1;
          const T = () => Object.assign(ne, { id: g.id, x: o.pageX, y: o.pageY, time: Date.now() });
          if (ne.id !== g.id || Re(o.pageX, o.pageY, ne.x, ne.y) > 10)
            return T(), !1;
          if (Date.now() - ne.time >= e.dragOpenDelay)
            return !0;
        }
      }, V = (o) => {
        var r, i;
        if (!(re && !((r = e.onExternalDragOver) != null && r.call(e, o))) && k && (o.preventDefault(), re)) {
          const { index: u } = k;
          (i = e.onExternalDrop) == null || i.call(e, o, k.parentStat, u), ie();
        }
      };
      function J(o) {
        var u, P;
        if (!f)
          return;
        const r = !k;
        if (!(((u = e.onDragEnd) == null ? void 0 : u.call(e, o, f, r)) === !1) && !r) {
          let L = k.index;
          k.parentStat === f.parentStat && f.index < L && L--;
          const y = [...e.data];
          if (e.dataType === "flat") {
            const g = ((P = k.parentStat) == null ? void 0 : P.id) ?? e.rootId, S = Oe(y, f.id, c), T = { ...f.node, [t]: g };
            S[0] = T;
            const v = ve(y, g, L, c);
            y.splice(v, 0, ...S);
          } else {
            const g = /* @__PURE__ */ new Map(), S = (b) => {
              if (!b)
                return y;
              const N = S(b.parentStat);
              let B = [...b.children];
              const H = g.get(b.node) || { ...b.node, [p]: B };
              return g.set(b.node, H), B = H[p], N[b.index] = H, B;
            }, T = S(f.parentStat), v = k.parentStat === f.parentStat ? T : S(k.parentStat);
            T.splice(f.index, 1), v.splice(L, 0, f.node);
          }
          e.onChange(y);
        }
        ie();
      }
      function ie() {
        A(void 0), w(void 0), ee(void 0);
      }
      function U(o, r) {
        var u, P;
        if (!o)
          return ((u = e.canDropToRoot) == null ? void 0 : u.call(e, r)) ?? !0;
        if (!o.open)
          return !1;
        let i = (P = e.canDrop) == null ? void 0 : P.call(e, o, r);
        return i == null && (i = U(o.parentStat)), i;
      }
      function he(o, r) {
        let i = o, u = E.indexOf(r ? e.placeholderId : o.id), P = !1;
        const L = (b) => b === h || d(b) === f, y = (b, N) => {
          let B = b, H;
          do
            B += N, H = E[B];
          while (H && L(H));
          return { id: H, i: B };
        }, g = (b, N) => {
          const B = y(b, N);
          i = d(B.id), u = B.i;
        }, S = 1;
        r && (g(u, -1), i || (P = !0, g(-1, S)));
        const v = d(y(u, S).id);
        return { closest: i, atTop: P, next: v };
      }
      function le(o, r) {
        const i = o ? o.childStats : O;
        let u = i.length;
        return r && r.siblingStats === i && (u = i.indexOf(r)), u;
      }
      return { visibleIds: E, attrsList: _, onDragOverRoot: z, onDropToRoot: V, onDragEndOnRoot: J };
    },
    [
      C,
      x,
      f,
      // watch placeholder position
      k == null ? void 0 : k.parentStat,
      k == null ? void 0 : k.index,
      // watch props
      x,
      h,
      a,
      e.rootId,
      // watch func
      ...[e.canDrop, e.canDropToRoot, e.customDragImage, e.onDragStart, e.onDragOver, e.onExternalDragOver, e.onExternalDrop, e.onDragEnd, e.onChange, e.onDragOpen].map((E) => I && E)
    ]
  ), ue = X(() => ({
    getEl: () => window,
    onDragOverWindow: (E) => {
      _() || (A(void 0), e.keepPlaceholder || ee(void 0));
      function _() {
        let F = !1, z = E.target;
        if (z) {
          for (const V of Se(z, "parentElement", { withSelf: !0 }))
            if (V === $.current) {
              F = !0;
              break;
            }
        }
        return F;
      }
    }
  }), [e.keepPlaceholder]);
  Ae(ue.getEl, "dragover", ue.onDragOverWindow);
  const { visibleIds: se, attrsList: ge, onDragOverRoot: ke, onDropToRoot: Te, onDragEndOnRoot: Ee } = we, me = X(() => f ? [se.indexOf(f.id)] : [], [f, se]);
  return {
    ...C,
    // 
    visibleIds: se,
    attrsList: ge,
    // ref
    virtualListRef: Y,
    // drag states
    draggingStat: f,
    dragOverStat: M,
    placeholder: k,
    // render
    renderHeTree: (E) => {
      let _ = e.renderNodeBox;
      if (!_) {
        const F = /* @__PURE__ */ de("div", { className: "he-tree-drag-placeholder", style: { minHeight: "20px", border: "1px dashed blue" } });
        _ = ({ stat: z, attrs: V, isPlaceholder: J }) => /* @__PURE__ */ de("div", { ...V, children: J ? F : e.renderNode(z) });
      }
      return /* @__PURE__ */ de("div", { className: `he-tree ${(E == null ? void 0 : E.className) || ""}`, style: E == null ? void 0 : E.style, ref: $, onDragOver: ke, onDrop: Te, onDragEnd: Ee, children: /* @__PURE__ */ de(
        Pe,
        {
          ref: Y,
          items: se,
          virtual: e.virtual,
          persistentIndices: me,
          style: { height: "100%" },
          renderItem: (F, z) => _({
            stat: d(F),
            attrs: ge[z],
            isPlaceholder: F === h
          })
        }
      ) });
    }
  };
}
function _e(s, e, n = "children") {
  for (const t of j(s, n))
    e(...t);
}
function* j(s, e = "children") {
  let n = !1, t = !1;
  const p = () => {
    n = !0;
  }, h = () => {
    t = !0;
  };
  yield* I(s, null, []);
  function* I(c, a, l) {
    let D = 0;
    for (const m of c) {
      if (yield [m, { parent: a, parents: l, siblings: c, index: D, skipChildren: p, exitWalk: h }], t)
        return;
      if (D++, n)
        n = !1;
      else {
        const C = m[e];
        if (C && (yield* I(C, m, [...l, m]), t))
          return;
      }
    }
  }
}
function He(s, e, n = "children") {
  for (const t of j(s, n))
    if (e(...t))
      return t[0];
}
function ze(s, e, n = "children") {
  const t = [];
  for (const p of j(s, n))
    e(...p) && t.push(p[0]);
  return t;
}
function* Se(s, e, n = { withSelf: !1 }) {
  let t = s;
  for (; t; )
    (t !== s || n.withSelf) && (yield t), t = typeof e == "function" ? e(t) : t[e];
}
function Ve(s, e) {
  const n = { ...Z, ...e }, { idKey: t, parentIdKey: p } = n, h = /* @__PURE__ */ new Map();
  h.set(null, []);
  const I = h.get(null);
  for (const a of s) {
    const l = a[t];
    h.set(l, []);
  }
  for (const a of s) {
    const l = a[p];
    (h.get(l) || I).push(a);
  }
  function* c(a) {
    for (const l of a) {
      yield l;
      const D = l[t];
      yield* c(h.get(D));
    }
  }
  return [...c(I)];
}
const Z = {
  idKey: "id",
  parentIdKey: "parent_id"
};
function* oe(s, e) {
  const n = { ...Z, ...e }, { idKey: t, parentIdKey: p } = n;
  let h = !1, I = !1;
  const c = () => {
    h = !0;
  }, a = () => {
    I = !0;
  }, l = {}, D = {}, m = {}, K = [];
  let C, R = 0;
  for (const O of s) {
    const d = O[t], x = O[p] ?? null;
    l[d] = O;
    const f = l[x] || null;
    m[d] = [];
    const w = f ? m[x] : K, M = w.length;
    w.push(d);
    const A = {
      parent: f,
      parents: f ? [...D[x].parents, f] : [],
      index: M,
      id: d,
      pid: x,
      treeIndex: R,
      skipChildren: c,
      exitWalk: a
    };
    D[d] = A;
    let Y = !1;
    if (h && C && (C.has(x) ? (C.add(d), Y = !0) : (h = !1, C = void 0)), !Y) {
      if (yield [O, A], I)
        break;
      h && (C = /* @__PURE__ */ new Set([d]));
    }
    R++;
  }
}
function We(s, e, n) {
  for (const t of oe(s, n))
    e(...t);
}
function ve(s, e, n, t) {
  const p = { ...Z, ...t }, { idKey: h, parentIdKey: I } = p;
  let c = !1, a = -1;
  for (const [l, { treeIndex: D, skipChildren: m, index: K }] of oe(s, p))
    if (e != null && !c)
      l[h] === e && (c = !0);
    else if (e == null || l[I] === e)
      if (n != null && n === K) {
        a = D;
        break;
      } else
        m();
    else {
      a = D;
      break;
    }
  return a === -1 && (a = s.length), a;
}
function qe(s, e, n, t) {
  const p = { ...Z, ...t }, { idKey: h, parentIdKey: I } = p, c = e[I] ?? null, a = ve(s, c, n, p);
  s.splice(a, 0, e);
}
function Oe(s, e, n) {
  if (e == null)
    return s.splice(0, s.length);
  const t = { ...Z, ...n }, { idKey: p, parentIdKey: h } = t;
  let I = -1, c = -1;
  for (const [a, { treeIndex: l, skipChildren: D }] of oe(s, t))
    if (I === -1)
      a[p] === e && (I = l, D());
    else {
      c = l;
      break;
    }
  return c === -1 && (c = s.length), I === -1 ? [] : s.splice(I, c - I);
}
function Xe(s, e, n, t) {
  const p = { ...Z, ...t }, { idKey: h, parentIdKey: I } = p, c = new Set(e), a = Array.isArray(n) ? n : [n], l = new Set(a);
  if (l.size > 0)
    for (const [D, { parents: m }] of oe(s, p)) {
      const K = D[h];
      if (l.has(K)) {
        for (const C of m)
          c.add(C[h]);
        if (l.delete(K), l.size === 0)
          break;
      }
    }
  return Array.from(c).sort();
}
const be = {
  idKey: "id",
  childrenKey: "children"
};
function je(s, e, n, t) {
  const p = { ...be, ...t }, { idKey: h, childrenKey: I } = p, c = new Set(e), a = Array.isArray(n) ? n : [n], l = new Set(a);
  if (l.size > 0)
    for (const [D, { parents: m }] of j(s, p.childrenKey)) {
      const K = D[h];
      if (l.has(K)) {
        for (const C of m)
          c.add(C[h]);
        if (l.delete(K), l.size === 0)
          break;
      }
    }
  return Array.from(c).sort();
}
function Ye(s, e, n, t, p) {
  const h = new Set(e), I = Array.isArray(n) ? n : [n], c = /* @__PURE__ */ new Map(), a = new Set(I), l = /* @__PURE__ */ new Map(), D = [];
  l.set(null, D);
  for (const [R, { parents: O, id: d, pid: x }] of oe(s, p))
    l.get(x).push(d), l.set(d, []), c.set(d, h.has(d)), (a.has(d) || x && a.has(x)) && (c.set(d, t), a.add(d));
  const m = (R) => {
    const O = l.get(R);
    if (!O || O.length === 0)
      return c.get(R);
    let d = !1, x = !1, f = !1;
    for (const M of O) {
      let A = m(M);
      A === !1 ? x = !0 : A === null ? f = !0 : d = !0;
    }
    let w;
    return f || x && d ? w = null : x ? w = !1 : w = !0, c.set(R, w), w;
  };
  for (const R of D)
    m(R);
  const K = [], C = [];
  return c.forEach((R, O) => {
    R === !0 ? K.push(O) : R === null && C.push(O);
  }), [K.sort(), C.sort()];
}
function $e(s, e, n, t, p) {
  const h = { ...be, ...p }, { idKey: I, childrenKey: c } = h, a = new Set(e), l = Array.isArray(n) ? n : [n], D = /* @__PURE__ */ new Map(), m = new Set(l), K = /* @__PURE__ */ new Map();
  K.set(null, []);
  for (const [d, { parents: x, parent: f }] of j(s, c)) {
    const w = d[I], M = (f == null ? void 0 : f[I]) ?? null;
    K.get(M).push(w), K.set(w, []), D.set(w, a.has(w)), (m.has(w) || M && m.has(M)) && (D.set(w, t), m.add(w));
  }
  const C = (d) => {
    const x = K.get(d);
    if (!x || x.length === 0)
      return D.get(d);
    let f = !1, w = !1, M = !1;
    for (const Y of x) {
      let $ = C(Y);
      $ === !1 ? w = !0 : $ === null ? M = !0 : f = !0;
    }
    let A;
    return M || w && f ? A = null : w ? A = !1 : A = !0, D.set(d, A), A;
  };
  for (const d of s)
    C(d[I]);
  const R = [], O = [];
  return D.forEach((d, x) => {
    d === !0 ? R.push(x) : d === null && O.push(x);
  }), [R.sort(), O.sort()];
}
function Re(s, e, n, t) {
  return Math.sqrt(Math.pow(n - s, 2) + Math.pow(t - e, 2));
}
function Ae(s, e, n) {
  Ce(() => {
    const t = s();
    return t == null || t.addEventListener(e, n), () => {
      t == null || t.removeEventListener(e, n);
    };
  }, [s, e, n]);
}
export {
  qe as addToFlatData,
  ve as convertIndexToTreeIndexInFlatData,
  Ke as defaultProps,
  ze as filterTreeData,
  He as findTreeData,
  Xe as openParentsInFlatData,
  je as openParentsInTreeData,
  Oe as removeByIdInFlatData,
  Ve as sortFlatData,
  Ye as updateCheckedInFlatData,
  $e as updateCheckedInTreeData,
  Me as useHeTree,
  We as walkFlatData,
  oe as walkFlatDataGenerator,
  Se as walkParentsGenerator,
  _e as walkTreeData,
  j as walkTreeDataGenerator
};
